/*
 * pb.h
 *
 *  Created on: Jun 16, 2015
 *      Author: a0220433
 */

#ifndef PB_H_
#define PB_H_

#include <stdbool.h>

#define	LED_ON				0x01
#define	LED_BLINK_RSOC		0x02
#define	LED_BLINK_FAULT		0x04
#define	LED_ON_3S			0x08
#define LED_BLINK_OTG_FAULT 0x10
#define LED_BLINK_UV        0x20

#define USE_MSP430_ADC_IBAT_IBUS
//#undef  USE_MSP430_ADC_IBAT_IBUS

typedef struct {

	unsigned char rsoc;

	int snk_vbus_mv;
	int snk_vbus_ma;

	int	bat_volt;
	int bat_curr;
	int bus_curr;
	int ioA_curr;


//	int vbus_volt;
	bool ac_pres;
	bool pd_connected;
	bool cc_attached;
	
	bool otg_fault;

	bool otg_active;
	bool is_charging;
	bool is_charge_done;
	bool key_pressed;       //act as USB A port output enable
	bool led_event_ongoing;

	bool loadA_pres;
	bool is_overloaded;     // USB A port overloaded
	bool is_undervoltage;   // USB A port undervoltage
	bool uv_checked;

	unsigned char charge_fault;

	unsigned char ibat_gain;
	unsigned char ibus_gain;

	unsigned char led_ctrl;	//BIT0 - LED Display Enable
							//BIT1 - LED blink for RSOC display
							//BIT2 - LED blink for fault
							//BIT3 - only display 3s
}power_bank_t;


struct pb_config {
    signed char bus_rsense;
    signed char bat_rsense;
    unsigned char cell_num;
    unsigned short charge_voltage;
    unsigned short charge_current;
    unsigned short tape_current;

    unsigned short loadA_over_current;
    unsigned short loadA_min_current;
    unsigned short batt_uv_threshold;
    unsigned short batt_shutdown_volt;
};


#endif /* PB_H_ */
