/*
 * volt_rsoc.c
 *
 *  Created on: Jun 15, 2015
 *      Author: a0220433
 */
static const unsigned int volt_level[] = {9300, 10300, 11200, 11950};
static const unsigned int volt_level2[] = {9400,10400, 11300, 12050};
static const unsigned char rsoc_table[] = {0,25,50,75,100};

static unsigned char idx_volt_level(const unsigned int *volt_array, unsigned char size, unsigned int volt)
{
	unsigned char idx = 0;
	while(idx < size){
		if(volt < volt_array[idx])
			return idx;
		idx++;
	}
	return idx;
}

unsigned char rsoc_update(int volt)
{
	static signed char last_rsoc = -1;
	signed char rsoc;
	unsigned char idx = 0;


	idx = idx_volt_level(&volt_level[0],sizeof(volt_level)/sizeof(unsigned int),volt);

	if (last_rsoc != -1 && (idx > 0 && volt < volt_level2[idx-1]))
		rsoc = last_rsoc;
	else {
		rsoc = rsoc_table[idx];
		last_rsoc = rsoc;
	}
	return rsoc;
}
