#include <stdbool.h>
#include <stdint.h>

typedef enum
{
	I2C_FREQ_100KHZ = 0,
	I2C_FREQ_400KHZ,
	I2C_FREQ_1MHZ
} i2c_freq_t;

typedef enum
{
    STATUS_OK = 0,
    STATUS_TIMEOUT,
    STATUS_NACK
} i2c_status_t;

typedef struct
{
	uint32_t base_addr;

    uint8_t byte_cnt;
    uint8_t xfer_len;

    uint8_t *buf;
    bool send_stop; /* for Tx */

    volatile bool xfer_cmplt;
    volatile bool xfer_timeout;
    volatile bool nack;
} i2c_master_t;


i2c_status_t i2c_master_read_register(i2c_master_t *i2c, uint8_t slave_addr, uint8_t reg, void *data, uint8_t len);
i2c_status_t i2c_master_write_register(i2c_master_t *i2c, uint8_t slave_addr, uint8_t reg, const void *data, uint8_t len);
i2c_status_t i2c_master_hdmi_read(i2c_master_t *i2c, uint8_t slave_addr, uint8_t segment, uint8_t reg, void *data, uint8_t len);

void i2c_master_init(i2c_master_t *i2c, uint32_t base_addr, uint32_t bus_clk, i2c_freq_t freq);

bool i2c_master_isr(i2c_master_t *i2c);

